# coding: utf-8

#
# Copyright 2018 Radiant Solutions
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

"""
    DeepCore Server
    A server that runs object detection models

    OpenAPI spec version: 1.3.2-SNAPSHOT
    Contact: deepcore-support@digitalglobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from deepcore_server.models.lat_lon_coord import LatLonCoord  # noqa: F401,E501


class LatLonBoundingBox(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'tl': 'LatLonCoord',
        'br': 'LatLonCoord'
    }

    attribute_map = {
        'tl': 'tl',
        'br': 'br'
    }

    def __init__(self, tl=None, br=None):  # noqa: E501
        """LatLonBoundingBox - a model defined in Swagger"""  # noqa: E501

        self._tl = None
        self._br = None
        self.discriminator = None

        if tl is not None:
            self.tl = tl
        if br is not None:
            self.br = br

    @property
    def tl(self):
        """Gets the tl of this LatLonBoundingBox.  # noqa: E501


        :return: The tl of this LatLonBoundingBox.  # noqa: E501
        :rtype: LatLonCoord
        """
        return self._tl

    @tl.setter
    def tl(self, tl):
        """Sets the tl of this LatLonBoundingBox.


        :param tl: The tl of this LatLonBoundingBox.  # noqa: E501
        :type: LatLonCoord
        """

        self._tl = tl

    @property
    def br(self):
        """Gets the br of this LatLonBoundingBox.  # noqa: E501


        :return: The br of this LatLonBoundingBox.  # noqa: E501
        :rtype: LatLonCoord
        """
        return self._br

    @br.setter
    def br(self, br):
        """Sets the br of this LatLonBoundingBox.


        :param br: The br of this LatLonBoundingBox.  # noqa: E501
        :type: LatLonCoord
        """

        self._br = br

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LatLonBoundingBox, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LatLonBoundingBox):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
