# coding: utf-8

#
# Copyright 2018 Radiant Solutions
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#         http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

"""
    DeepCore Server
    A server that runs object detection models

    OpenAPI spec version: 1.3.2-SNAPSHOT
    Contact: deepcore-support@digitalglobe.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from deepcore_server.models.point import Point  # noqa: F401,E501
from deepcore_server.models.size import Size  # noqa: F401,E501


class SizeStep(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'size': 'Size',
        'step': 'Point'
    }

    attribute_map = {
        'size': 'size',
        'step': 'step'
    }

    def __init__(self, size=None, step=None):  # noqa: E501
        """SizeStep - a model defined in Swagger"""  # noqa: E501

        self._size = None
        self._step = None
        self.discriminator = None

        if size is not None:
            self.size = size
        if step is not None:
            self.step = step

    @property
    def size(self):
        """Gets the size of this SizeStep.  # noqa: E501


        :return: The size of this SizeStep.  # noqa: E501
        :rtype: Size
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this SizeStep.


        :param size: The size of this SizeStep.  # noqa: E501
        :type: Size
        """

        self._size = size

    @property
    def step(self):
        """Gets the step of this SizeStep.  # noqa: E501


        :return: The step of this SizeStep.  # noqa: E501
        :rtype: Point
        """
        return self._step

    @step.setter
    def step(self, step):
        """Sets the step of this SizeStep.


        :param step: The step of this SizeStep.  # noqa: E501
        :type: Point
        """

        self._step = step

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(SizeStep, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SizeStep):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
